diff -ruNp ejudge-2.3.18/compile.c ejudge/compile.c
--- ejudge-2.3.18/compile.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/compile.c	2011-07-11 09:02:04.582272683 +0400
@@ -1,5 +1,5 @@
 /* -*- c -*- */
-/* $Id: compile.c 6214 2011-04-01 20:03:14Z cher $ */
+/* $Id: compile.c 6393 2011-07-04 20:54:33Z cher $ */
 
 /* Copyright (C) 2000-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -78,6 +78,7 @@ check_style_only(
   size_t reply_bin_size = 0;
   unsigned char msgbuf[1024] = { 0 };
   path_t log_path;
+  path_t txt_path;
   path_t work_src_path;
   path_t work_log_path;
   path_t work_txt_path;
@@ -91,6 +92,7 @@ check_style_only(
   // working directory: ${global->compile_work_dir}
 
   snprintf(log_path, sizeof(log_path), "%s/%s", report_dir, run_name);
+  snprintf(txt_path, sizeof(txt_path), "%s/%s.txt", report_dir, run_name);
   if (req->src_sfx) src_sfx = req->src_sfx;
   snprintf(work_src_path, sizeof(work_src_path), "%s/%s%s",
            global->compile_work_dir, run_name, src_sfx);
@@ -171,11 +173,12 @@ check_style_only(
     rpl->status = RUN_STYLE_ERR;
     get_current_time(&rpl->ts3, &rpl->ts3_us);
     generic_copy_file(0, 0, work_log_path, "", 0, 0, log_path, "");
+    generic_copy_file(0, 0, work_txt_path, "", 0, 0, txt_path, "");
   } else {
     // success
     rpl->status = RUN_OK;
     get_current_time(&rpl->ts3, &rpl->ts3_us);
-    generic_copy_file(0, 0, work_txt_path, "", 0, 0, log_path, "");
+    generic_copy_file(0, 0, work_txt_path, "", 0, 0, txt_path, "");
   }
 
   if (compile_reply_packet_write(rpl, &reply_bin_size, &reply_bin) < 0)
@@ -213,9 +216,11 @@ do_loop(void)
   path_t src_path;
   path_t exe_path;
   path_t log_path;
+  path_t txt_path;
 
   path_t exe_out;
   path_t log_out;
+  path_t txt_out;
   path_t report_dir, status_dir;
 
   path_t  pkt_name, run_name;
@@ -323,6 +328,7 @@ do_loop(void)
              "%s/%06d/status", global->compile_dir, rpl.contest_id);
     snprintf(run_name, sizeof(run_name), "%06d", rpl.run_id);
     pathmake(log_out, report_dir, "/", run_name, NULL);
+    snprintf(txt_out, sizeof(txt_out), "%s/%s.txt", report_dir, run_name);
 
     make_all_dir(status_dir, 0777);
     make_dir(report_dir, 0777);
@@ -355,6 +361,7 @@ do_loop(void)
     pathmake(src_path, global->compile_work_dir, "/", src_name, NULL);
     pathmake(exe_path, global->compile_work_dir, "/", exe_name, NULL);
     pathmake(log_path, global->compile_work_dir, "/", "log", NULL);
+    pathmake(txt_path, global->compile_work_dir, "/", "txt", NULL);
     /* the resulting executable file */
     pathmake(exe_out, report_dir, "/", exe_name, NULL);
 
@@ -391,9 +398,9 @@ do_loop(void)
         task_SetPathAsArg0(tsk);
         task_SetWorkingDir(tsk, global->compile_work_dir);
         task_EnableProcessGroup(tsk);
-        task_SetRedir(tsk, 1, TSR_FILE, log_path, TSK_REWRITE, 0777);
         task_SetRedir(tsk, 0, TSR_FILE, "/dev/null", TSK_WRITE);
-        task_SetRedir(tsk, 2, TSR_DUP, 1);
+        task_SetRedir(tsk, 1, TSR_FILE, txt_path, TSK_REWRITE, 0777);
+        task_SetRedir(tsk, 2, TSR_FILE, log_path, TSK_REWRITE, 0777);
         if (req->sc_env_num > 0) {
           for (i = 0; i < req->sc_env_num; i++)
             task_PutEnv(tsk, req->sc_env_vars[i]);
@@ -536,6 +543,9 @@ do_loop(void)
       } else {
         r = generic_copy_file(0, 0, exe_path, "", 0, 0, exe_out, "");
       }
+      if (generic_file_size(0, txt_path, "") > 0) {
+        generic_copy_file(0, 0, txt_path, "", 0, 0, txt_out, "");
+      }
       if (r >= 0 && generic_write_file(rpl_pkt, rpl_size, SAFE,
                                        status_dir, run_name, "") >= 0)
         break;
@@ -888,7 +898,7 @@ main(int argc, char *argv[])
 #if HAVE_SETSID - 0
   if (daemon_mode) {
     // FIXME: make log file tunable?
-    snprintf(log_path, sizeof(log_path), "%s/compile.log",
+    snprintf(log_path, sizeof(log_path), "%s/ej-compile.log",
              serve_state.global->var_dir);
 
     // daemonize itself
diff -ruNp ejudge-2.3.18/configure.ac ejudge/configure.ac
--- ejudge-2.3.18/configure.ac	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/configure.ac	2011-07-11 09:02:04.034282758 +0400
@@ -1,9 +1,9 @@
-dnl $Id: configure.ac 6189 2011-03-27 15:59:42Z cher $
+dnl $Id: configure.ac 6388 2011-06-30 11:49:25Z cher $
 dnl Copyright (C) 2004-2011 Alexander Chernov <cher@ejudge.ru>
 
 AC_INIT(ejudge,2.3)
 AC_PREREQ(2.59)
-AC_REVISION($Revision: 6189 $)
+AC_REVISION($Revision: 6388 $)
 
 AC_PREFIX_DEFAULT([$HOME/inst-ejudge])
 AC_PROG_INSTALL
@@ -747,6 +747,44 @@ AC_MSG_RESULT([no])
 ac_cv_has___int64=""
 ])
 
+AC_MSG_CHECKING([for -m32 support])
+saved_CC="${CC}"
+CC="${CC} -m32 -fPIC -DPIC"
+AC_RUN_IFELSE([[
+#include <string.h>
+#include <stdio.h>
+int main(void)
+{
+  printf("");
+  return 0;
+}
+]],[
+AC_MSG_RESULT([yes])
+ac_cv_need_32=1
+],[
+AC_MSG_RESULT([no])
+])
+CC="${saved_CC}"
+
+AC_MSG_CHECKING([for -m64 support])
+saved_CC="${CC}"
+CC="${CC} -m64 -fPIC -DPIC"
+AC_RUN_IFELSE([[
+#include <string.h>
+#include <stdio.h>
+int main(void)
+{
+  printf("");
+  return 0;
+}
+]],[
+AC_MSG_RESULT([yes])
+ac_cv_need_64=1
+],[
+AC_MSG_RESULT([no])
+])
+CC="${saved_CC}"
+
 dnl localization stuff
 
 if [[ x"${ac_cv_nls}" = xno ]]
@@ -970,6 +1008,8 @@ AC_SUBST(ac_cv_has_lib_libiconv)
 AC_SUBST(ac_cv_has_lib_intl)
 AC_SUBST(ac_cv_has_lib_libzip)
 AC_SUBST(ac_cv_meta_cc)
+AC_SUBST(ac_cv_need_32)
+AC_SUBST(ac_cv_need_64)
 
 AC_SUBST(ac_cv_festival_home)
 AC_SUBST(ac_cv_libcap_link)
diff -ruNp ejudge-2.3.18/contest-1/contest-1.c ejudge/contest-1/contest-1.c
--- ejudge-2.3.18/contest-1/contest-1.c	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/contest-1.c	2011-07-11 09:02:01.450330222 +0400
@@ -0,0 +1,85 @@
+"begin-base64 664 contest-1.tar.gz\n"
+"H4sIAFQ/FU4AA+1dW2/bRhb2g1/CXzHQJoWU2DTvrGNJQS7ewthttrBT9KEt\n"
+"DIqkZSYUJZCUY7cokMToBUi6xe5LgQWKPu6rm9Zbp46dv0D9oz0zpCg5liyn\n"
+"UcZOdL7EIuc+nOE3c2bmzLAVNmu+24jmpt4cJIBp6unV0I5cM0zJsq4bsqGY\n"
+"CtjLsqpLU0R/g3nK0Y5iKyRkyl53w5P8jXJ/S9Hq1v/1N/cGvEL9q5Km0PrX\n"
+"FQXrnwf66j92o/iNtAOvXv+KAc5Y/xxwrP4lSRUdKx5nGrSCDU07of71KRl+\n"
+"NFNRDEWC+lepdyKNMxPDMOH1P6sJmnDWmUCcGQby3wqicabB+G+cxH9o86GD\n"
+"UBVJ1Qyd8d+Ukf88ICH5JxoD+K+dKf+B+JT/hon854H3kf8TjQH8l89S/tcN\n"
+"g/FfV5H/PCALsoBNwORiYP/Pnf9a3/jfRP5zBA7/JxsD+K+cKf+ltP/XDOQ/\n"
+"DyiCivyfYAzgv/5G+H/S+F9WgP+mCdw3Zbb+C+N/BfnPA7KiyoKmzc9jKzCR\n"
+"GDj+P8v5P93A+T+OUJD3E42B/T93/mu9/t9Q0vU/lP+5QDdVLsWMOJ8YOP4/\n"
+"0/X/bP0P9X+4QMf+f6LRx38gQuw23CAWNxv+ONMYwX9Z18ys/zcVQ1aB/5pi\n"
+"6Mh/Hihfg8omG24Yec2gUpBFqUDcwG46XlCvFNrx2uz7BXKtKpSzF0UghLQs\n"
+"+55Vd0mFFMK26N5tO3VXjKxGy3dX7WZA+5EC9ec51Mt1dh9vtVgAKO3AsUKn\n"
+"UAXbcv7KEd8K6m2ItAJRri5/zJzBQ+zFvltNfkx2kt+Snc63yQ65Xp5LbVMf\n"
+"jhvZodeKIfs0l9XkJ/DTedh5BEEOWKAHcH+QHCbPSfIiOQTDYfJHskuSp/Dv\n"
+"kPogye9Z/P/sPIKgPxAwPKXRfJPsJvudx52vCSS913mY7Cc7MwRig+DPwe2g\n"
+"86TzXbKX7Aqz0HlJEkn2MtdfIOr9rithjqIwJG+dx8mzvrxBzsAmz9sBeH6R\n"
+"7NJnZwGfwe8ujWUbsvC8s00634PNXi+PkGVRKM+1WHEIyX+7GR/wmJAmYemw\n"
+"8oG4kqcsf50HaSGJJPmZ3f/CCuIJyytNHJ7qOcsilA5h2XsAPn7rFRMr7r30\n"
+"qah5V6DlkvzKEmTJb7PfR/Cw2zRDLKltlniaRJ6LPZqrvLZ2h4VPH5m9E3NH\n"
+"Xgpqkb9ozOhuspc1yrxnxtQEZi9oteOqLCjlufS269Bsx9Solueyuyy5vghy\n"
+"A0QOGUpJUz2/nWx/+9/027TExr4HgLX3I/X/DUmVQP6T2Pyvrumo/88DA+vf\n"
+"Wm1txevNQBVbW2NIY+T6n26m+z8kEzp+Wv+GhOt/fGBBp+wFcZE1dMVSSai9\n"
+"bNEKqdEiV0itdH7bMcSfwxD+37U2LHs1ikV687ppjJL/JQXaf0mHYYAuKwod\n"
+"/xu6hPznAq/RaoYxodUsek3x8oIgtNo137PJmhdYPrF9K4qItaoJX4J0kzlR\n"
+"aQouG02Q8BuWFxRXYmgk6sQK69Gnn5fA45dMMgJr12rcad5zA+8LN4Rw0LgE\n"
+"7v2XHYrU7kZ7bc0NXWfZtZzMaom2QanfzHZlKwI5TvSCUqm0wNKAxolYM6QG\n"
+"GadGeGVDN3Ljla0gtjaLmSewdZv+UrTi1QNvzbMtaNHWLD9ye+73m6Fzc90K\n"
+"o6KqzhBF1/uc1j0Y08Cox009SDMg0JeyBONwK3ta5jdwN2P2XJA0oY3rEoyH\n"
+"6m4otiCkC4YieIo2LD+L/nig2mkCZeUAYqjI2mc/yFro1MNXxLZie50UFzdt\n"
+"l4nBZLOUZzML7G56cVHuhhDo31fYwE8YhrT/ddMU15pjavBGzf/KqsL0v3RJ\n"
+"NwyZ7v/UZZz/5YO0RVi6fWfxg8Xlyxo0pbUZO2snlhev3yLFyzOXS6yFzWxt\n"
+"aJ9YW5OZP1leurOYeeuGXLx9C1uStwJD+O/YNnQ+Y1oFGsl/Xe7qf6q0LQAL\n"
+"FeU/PoD6r4dWg0TtxoKwASVBmT4DJL9K/GZQB9FiQai5cKXMBkHMoZJGKjNk\n"
+"pkzmgBBZu8CM90OQmcDVBlc3cERsDs4nhvX/rTPmv4L85wLk/2Rj2PzvekuE\n"
+"v/GkMWr+V9bkfP5XNU3Gf9T/5IPyNahmwfeimBQvWiWQ7dci2wrWiit3bi3d\n"
+"niGFS04BKJx5qA31wGYhyEXaAFysEZEUPgsKC8K1c7zyhaAYwv+1M+//Uf+D\n"
+"C7D/n2wM6//d0BdbY9ICG6n/aXb5r9KlH8Z/Hef/uMBebzZa0PNDv15mPXoV\n"
+"CJtZ1o5YHunhF5DP7wZO1P8Yj/rHaP4bRjb/rxmKSvU/dVPH89+4oKv/EVr3\n"
+"V4/pgByxTPmfzvyfda4R48IQ/sdnLf9reP4LF6D8P9kYNv9/5Ypot8Y5/3cS\n"
+"/3P5X1FM02Dr/xrO/3HBX7zA9tuOS8peM2KaVlWhHVFlrsBqpEpPJIqdBYF2\n"
+"/kzXq8Q0wXpqV0B9LyDVKrH67lP7Zjsm5XKvVQjduB0GRFpARaPzgpP1P20e\n"
+"+p+Sxs5/SfU/ddlM9T9R/ueC4/qf/TbwPvjiim0FgRsO0wytvYJmKInXw+b9\n"
+"iORqiT1V0TQREnU1RFNzn8LnQHVPOnyJmP4k1ZLM/NQGWZ6oMTm5mo/D+n/7\n"
+"7liozzCC/7KkyN3zH3TNYON/zcT5Py44nf73h0BlVABHBXDEu4Yh7X/jiwga\n"
+"vIYrRnbjtdMYOf/L9v+z8Z+pa2z/n4b6n3xQdLyo5VtbpHiFFOmMTim7lEoC\n"
+"bYJ9L3BLeEL4O4uh8p8t2uNKY+T8j5Gf/6MoJp3/1UwD53+5oDf/E8UOCIDr\n"
+"VaE31UPlu5ene8CQ6n8VLjmXnMIMeQ/s30vlDiaJMJfPAnDpCSQ48XNeMYz/\n"
+"67a4Pq5DwEbyn37/Izv/QVW1dP5XQv7zAOU5uXqVLP2DFEsCM1VI3Y1v0nN8\n"
+"gjgi1Wol5TUR6SIR/DasFlv7gVs6ZopQOniLMYT/tVaL4/pPfv6XYeiKmup/\n"
+"4/wvFxxf/6EiwEuLPXQlGFd73kkM4X/Yrm2JYW08aTD+n3T+Dwj7Xf5rKtv/\n"
+"rZp4/j8XWGl3H4lM55NpfvUZW22QACwxbq56lNXsBrn8LmGY/L/WDOPQCsZy\n"
+"CMTI/v/Y+Q+GJiH/uQDPf5hsDJP/+c7/Gfn6LwwA2Pwf9v98cMr5v74RQN8E\n"
+"oO/A/yFTgD7OAb4NGML/e+2GF4rwO440Rsn/smq8dP6nbqo4/88F0vTCtDot\n"
+"TFWmpekP4PrXaR1syJQ1NTNFpmpTwpQyrUxXpzVm129K3f7W50qmrmRhroJd\n"
+"ZRppfv4xhP8btcAWN8Y5/j+h/1dk9v0fw9Tp8f/p/B+e/8sHHzadtu8Sqyas\n"
+"tGtMz6tYEm55jXwfiBV1lZEEOldwE96Ppu+KVB3r717gFtPdYgOse+OEruMn\n"
+"dE8Ic7VLwmLgEEiSXdNMYHNxBhim/2NHos1r/U+V1Jz/msTOf1FQ/5sP0r0e\n"
+"qUIgyPY9dc+b9A5k/wv9up6sfYiYruennzNtz5JwAfxcSLeGMr1FVRE/olqL\n"
+"xeNtAowDUq+103k93nAUvpS+6htVXECNxdfE0PPfwqbfrItwef00Ro//1e7+\n"
+"b02Wmf6fgvs/+eASmb08S9LaprfC1VniBV7sWb73hUVfhyKdCiiJqW4AuNKl\n"
+"/9Wg3ai5YfF6aeaI+QaYbxIvIteBoDdm0l2gxZtgG/gzZN3yYxG1Bc4VhvB/\n"
+"y6pZkWeLtXHsAR/Ff0mXcv1fVWf7v2T8/hcfLN3+6OM7pFAglpDf1vpk94+W\n"
+"l27fITaS9h1Fzv8b4/7qUw+M7yO//6TrwHpV0uj8v0zVgPD7TxzQV//p91/f\n"
+"QBqvXv+KYeD3v7jgWP3DcFx0rHicadAK1k6c/5e7+78VKf3+m4HnP/CBnEGQ\n"
+"FYbuFW7mUxy76VnkNvNHrvSCAsPbgYH85/39b7mP/7qefv8b+c8F8/PQ70LJ\n"
+"I18nEwP4L/Pu/0Hey/f/yWz8rxp4/iMfyIIiqIIm6NgATCQG8F/hzn+65+dl\n"
+"/uP5L1wgS5IAgy5BhT8N/mY1bAgmCQP7f97yv5TzX9WVTP5H/R8ukLHjn2gM\n"
+"7P+581/r8V+VU/7j+h8XzM8b2ABMMPr4TxW93IYbxOJmY0xffkkxgv+yobH9\n"
+"P6qqmQY9C0SSNQXP/+GD8jWobLLhhpHXDCoFWZQKxA3spuMF9UqhHa/Nvl8g\n"
+"16pCOXtR6Aa/lmXfs+ouqZBC2Bbdu22n7oqR1Wj57qpNzw2J4gL15znUyw12\n"
+"H2+1WAAo7cCxQqdQBdty/soR3wrqbYi0AlGuLn/MnMFD7MW+W01+THaS35Kd\n"
+"zrfJDrlRnkttUx+OG9mhx444pLmsJj+Bn87DziMIcsACPYD7g+QweU6SF8kh\n"
+"GA6TP5JdkjyFf4fUB0l+z+L/V+cRBP0h9fgw2U92wfoQ/O1AsN1kv/OExkRj\n"
+"7zwhnW+Y1ePO1wQytgf+wSgKyX8gsv+xcLtdh/3k8BRxJnsEbiFnz8H+oPOk\n"
+"8x0YZpWMJiR3/gWC72fOXVdI998sB7+eKima/YdZqoeQxUf9UYNXlvNdWmR7\n"
+"ye9Ek44+4c+niJ6V6dNkF4r/O7jbzUu284DGCT53oBpYrdDLAZTmTl+dQCqD\n"
+"K7LzOHnWV5EQBGzyiqSxvoDEvmV52kme0ZzRWLahUJ93tknne1rOL1VZea6V\n"
+"vU1zR14napG/oszobrLXPMq8Z8Zqtu21zD6WUpWJQlSiledSY9ex2Y6Zq1Se\n"
+"y26zNPtiyQ2QAuQq5dyb/Ihif/uf63+NOY1XX/9XdUPB9X8eGFj/Nb7n/yk9\n"
+"+V8BGSA9/w/lfy54hfP/6NHs0gzZZFuA7697vkuK+VGAdBfwZolUKkQupccm\n"
+"kysV6vfYqYAR7gZGIBAIBAKBQCAQCAQCgUAgEAgEAoFAIBAIBAKBQCAQCAQC\n"
+"gUAg/iT+D2azPlgA8AAA\n"
+"====\n"
Binary files ejudge-2.3.18/contest-1/contest-1.tar.gz and ejudge/contest-1/contest-1.tar.gz differ
diff -ruNp ejudge-2.3.18/contest-1/make-c.sh ejudge/contest-1/make-c.sh
--- ejudge-2.3.18/contest-1/make-c.sh	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/make-c.sh	2011-07-11 09:02:01.448330258 +0400
@@ -0,0 +1,35 @@
+#! /bin/sh
+# $Id: make-c.sh 6275 2011-04-28 03:59:21Z cher $
+
+filename="$1"
+infile="$2"
+outfile="$3"
+
+if [ x"${filename}" = x"" ]
+then
+    echo "filename parameter is not specified" >&2
+    exit 1
+fi
+if [ x"${infile}" = x"" ]
+then
+    echo "infile parameter is not specified" >&2
+    exit 1
+fi
+if [ x"${outfile}" = x"" ]
+then
+    echo "outfile parameter is not specified" >&2
+    exit 1
+fi
+
+if [ ! -f "${infile}" ]
+then
+    echo "${infile} does not exist" >&2
+    exit 1
+fi
+
+if uuencode --help > /dev/null
+then
+    uuencode -m contest-1.tar.gz < contest-1/contest-1.tar.gz | sed 's/$/\\n"/g' | sed 's/^/"/g' > contest-1/contest-1.c
+else
+    touch contest-1/contest-1.c
+fi
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_bcc.c ejudge/contest-1/problems/A/solutions/a_bcc.c
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_bcc.c	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_bcc.c	2011-07-11 09:02:00.713343749 +0400
@@ -0,0 +1,10 @@
+#include <stdio.h>
+
+int main(void)
+{
+  long a, b;
+
+  scanf("%ld%ld", &a, &b);
+  printf("%ld\n", a + b);
+  return 0;
+}
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_bpp.cpp ejudge/contest-1/problems/A/solutions/a_bpp.cpp
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_bpp.cpp	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_bpp.cpp	2011-07-11 09:02:00.709343823 +0400
@@ -0,0 +1,9 @@
+#include <iostream.h>
+int main()
+{
+  long a, b;
+  cin >> a;
+  cin >> b;
+  cout << a + b;
+  return 0;
+}
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_dcc.pas ejudge/contest-1/problems/A/solutions/a_dcc.pas
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_dcc.pas	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_dcc.pas	2011-07-11 09:02:00.728343475 +0400
@@ -0,0 +1,8 @@
+program sum;
+var a, b, c : longint;
+begin
+   readln(a);
+   readln(b);
+   c := a + b;
+   writeln(c);
+end.
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_fpc.pas ejudge/contest-1/problems/A/solutions/a_fpc.pas
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_fpc.pas	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_fpc.pas	2011-07-11 09:02:00.685344264 +0400
@@ -0,0 +1,8 @@
+program sum;
+var a, b, c : longint;
+begin
+   readln(a);
+   readln(b);
+   c := a + b;
+   writeln(c);
+end.
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_g77.for ejudge/contest-1/problems/A/solutions/a_g77.for
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_g77.for	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_g77.for	2011-07-11 09:02:00.681344336 +0400
@@ -0,0 +1,5 @@
+      INTEGER*4 a,b,c
+      READ (*,*) a, b
+      c = a + b
+      WRITE (*,*) c
+      END
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_gcc.c ejudge/contest-1/problems/A/solutions/a_gcc.c
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_gcc.c	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_gcc.c	2011-07-11 09:02:00.738343290 +0400
@@ -0,0 +1,10 @@
+#include <stdio.h>
+
+int main(void)
+{
+  int a, b;
+
+  scanf("%d%d", &a, &b);
+  printf("%d\n", a + b);
+  return 0;
+}
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_gcj.java ejudge/contest-1/problems/A/solutions/a_gcj.java
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_gcj.java	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_gcj.java	2011-07-11 09:02:00.665344630 +0400
@@ -0,0 +1,23 @@
+import java.io.*;
+
+public final class Main
+{
+  public static void main(String args[])
+  {
+    StreamTokenizer st = new StreamTokenizer(new BufferedReader(new InputStreamReader(System.in)));
+    int a, b;
+
+    st.resetSyntax();
+    st.eolIsSignificant(false);
+    st.wordChars(33, 255);
+    st.whitespaceChars(0, 32);
+
+    try {
+      st.nextToken(); a = Integer.parseInt(st.sval);
+      st.nextToken(); b = Integer.parseInt(st.sval);
+      System.out.println(a + b);
+    } catch (Exception x) {
+      System.exit(1);
+    }
+  }
+}
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_g++.cpp ejudge/contest-1/problems/A/solutions/a_g++.cpp
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_g++.cpp	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_g++.cpp	2011-07-11 09:02:00.695344079 +0400
@@ -0,0 +1,10 @@
+#include <iostream>
+using namespace std;
+int main()
+{
+  int a, b;
+  cin >> a;
+  cin >> b;
+  cout << a + b;
+  return 0;
+}
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_gfortran.for ejudge/contest-1/problems/A/solutions/a_gfortran.for
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_gfortran.for	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_gfortran.for	2011-07-11 09:02:00.710343805 +0400
@@ -0,0 +1,5 @@
+      INTEGER*4 a,b,c
+      READ (*,*) a, b
+      c = a + b
+      WRITE (*,*) c
+      END
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_ghc.hs ejudge/contest-1/problems/A/solutions/a_ghc.hs
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_ghc.hs	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_ghc.hs	2011-07-11 09:02:00.726343511 +0400
@@ -0,0 +1,3 @@
+main :: IO ()
+main = getContents >>= print . sum . map read . words
+
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_gpc.pas ejudge/contest-1/problems/A/solutions/a_gpc.pas
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_gpc.pas	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_gpc.pas	2011-07-11 09:02:00.693344117 +0400
@@ -0,0 +1,8 @@
+program sum;
+var a, b, c : longint;
+begin
+   readln(a);
+   readln(b);
+   c := a + b;
+   writeln(c);
+end.
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_gprolog.pro ejudge/contest-1/problems/A/solutions/a_gprolog.pro
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_gprolog.pro	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_gprolog.pro	2011-07-11 09:02:00.711343787 +0400
@@ -0,0 +1,4 @@
+% -*- prolog -*-
+:- initialization(main).
+main :- read_number(A), read_number(B), C is A + B, write(C), nl, halt.
+
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_javac_sc.java ejudge/contest-1/problems/A/solutions/a_javac_sc.java
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_javac_sc.java	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_javac_sc.java	2011-07-11 09:02:00.683344300 +0400
@@ -0,0 +1,15 @@
+import java.io.*;
+import java.util.Scanner;
+
+public final class a_b
+{
+  public static void main(String args[]) throws Exception
+  {
+    Scanner s = new Scanner(System.in);
+    int a, b;
+
+    a = s.nextInt();
+    b = s.nextInt();
+    System.out.println(a + b);
+  }
+}
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_mcs.cs ejudge/contest-1/problems/A/solutions/a_mcs.cs
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_mcs.cs	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_mcs.cs	2011-07-11 09:02:00.666344612 +0400
@@ -0,0 +1,11 @@
+using System;
+
+class MainClass
+{
+	static void Main(string[] args)
+	{
+		int a = Int32.Parse(Console.ReadLine());
+		int b = Int32.Parse(Console.ReadLine());
+		Console.WriteLine("{0}", a + b);
+	}
+}
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_mzscheme.scm ejudge/contest-1/problems/A/solutions/a_mzscheme.scm
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_mzscheme.scm	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_mzscheme.scm	2011-07-11 09:02:00.694344098 +0400
@@ -0,0 +1,3 @@
+(display (+ (read) (read)))
+(newline)
+
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_perl.pl ejudge/contest-1/problems/A/solutions/a_perl.pl
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_perl.pl	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_perl.pl	2011-07-11 09:02:00.729343456 +0400
@@ -0,0 +1,3 @@
+chomp($a = <STDIN>);
+chomp($b = <STDIN>);
+print $a + $b;
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_php.php ejudge/contest-1/problems/A/solutions/a_php.php
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_php.php	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_php.php	2011-07-11 09:02:00.739343271 +0400
@@ -0,0 +1,5 @@
+<?php
+list ($a) = fscanf(STDIN, "%d");
+list ($b) = fscanf(STDIN, "%d");
+print $a + $b . "\n";
+?>
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_python3.py ejudge/contest-1/problems/A/solutions/a_python3.py
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_python3.py	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_python3.py	2011-07-11 09:02:00.691344153 +0400
@@ -0,0 +1,3 @@
+a = int(input())
+b = int(input())
+print(a + b)
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_python.py ejudge/contest-1/problems/A/solutions/a_python.py
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_python.py	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_python.py	2011-07-11 09:02:00.714343730 +0400
@@ -0,0 +1,3 @@
+a = int(raw_input())
+b = int(raw_input())
+print a + b
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_ruby.rb ejudge/contest-1/problems/A/solutions/a_ruby.rb
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_ruby.rb	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_ruby.rb	2011-07-11 09:02:00.663344666 +0400
@@ -0,0 +1,3 @@
+a = gets.chomp
+b = gets.chomp
+puts a.to_i + b.to_i
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_tpc.pas ejudge/contest-1/problems/A/solutions/a_tpc.pas
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_tpc.pas	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_tpc.pas	2011-07-11 09:02:00.715343712 +0400
@@ -0,0 +1,8 @@
+program sum;
+var a, b, c : longint;
+begin
+   readln(a);
+   readln(b);
+   c := a + b;
+   writeln(c);
+end.
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_vbnc.vb ejudge/contest-1/problems/A/solutions/a_vbnc.vb
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_vbnc.vb	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_vbnc.vb	2011-07-11 09:02:00.697344042 +0400
@@ -0,0 +1,9 @@
+Module ab
+Sub Main()
+Dim a, b, c as Integer
+a = Console.ReadLine()
+b = Console.ReadLine()
+c = a + b
+Console.WriteLine(c)
+End Sub
+End Module
diff -ruNp ejudge-2.3.18/contest-1/problems/A/solutions/a_yabasic.bas ejudge/contest-1/problems/A/solutions/a_yabasic.bas
--- ejudge-2.3.18/contest-1/problems/A/solutions/a_yabasic.bas	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/solutions/a_yabasic.bas	2011-07-11 09:02:00.651344887 +0400
@@ -0,0 +1,4 @@
+INPUT "" a
+INPUT "" b
+c = a + b
+PRINT c
diff -ruNp ejudge-2.3.18/contest-1/problems/A/tests/001.ans ejudge/contest-1/problems/A/tests/001.ans
--- ejudge-2.3.18/contest-1/problems/A/tests/001.ans	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/tests/001.ans	2011-07-11 09:02:00.800342152 +0400
@@ -0,0 +1 @@
+2
diff -ruNp ejudge-2.3.18/contest-1/problems/A/tests/002.ans ejudge/contest-1/problems/A/tests/002.ans
--- ejudge-2.3.18/contest-1/problems/A/tests/002.ans	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/tests/002.ans	2011-07-11 09:02:00.802342116 +0400
@@ -0,0 +1 @@
+5
diff -ruNp ejudge-2.3.18/contest-1/problems/A/tests/003.ans ejudge/contest-1/problems/A/tests/003.ans
--- ejudge-2.3.18/contest-1/problems/A/tests/003.ans	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/tests/003.ans	2011-07-11 09:02:00.803342098 +0400
@@ -0,0 +1 @@
+0
diff -ruNp ejudge-2.3.18/contest-1/problems/A/tests/004.ans ejudge/contest-1/problems/A/tests/004.ans
--- ejudge-2.3.18/contest-1/problems/A/tests/004.ans	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/tests/004.ans	2011-07-11 09:02:00.806342043 +0400
@@ -0,0 +1 @@
+8
diff -ruNp ejudge-2.3.18/contest-1/problems/A/tests/005.ans ejudge/contest-1/problems/A/tests/005.ans
--- ejudge-2.3.18/contest-1/problems/A/tests/005.ans	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/A/tests/005.ans	2011-07-11 09:02:00.808342005 +0400
@@ -0,0 +1 @@
+5730
\ No newline at end of file
diff -ruNp ejudge-2.3.18/contest-1/problems/B/solutions/b_gcc.c ejudge/contest-1/problems/B/solutions/b_gcc.c
--- ejudge-2.3.18/contest-1/problems/B/solutions/b_gcc.c	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/B/solutions/b_gcc.c	2011-07-11 09:02:00.979338868 +0400
@@ -0,0 +1,11 @@
+#include <stdio.h>
+
+int main(void)
+{
+  int s = 0, x;
+
+  while (scanf("%d", &x) == 1)
+    s += x;
+  printf("%d\n", s);
+  return 0;
+}
diff -ruNp ejudge-2.3.18/contest-1/problems/B/tests/001.ans ejudge/contest-1/problems/B/tests/001.ans
--- ejudge-2.3.18/contest-1/problems/B/tests/001.ans	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/B/tests/001.ans	2011-07-11 09:02:01.140335913 +0400
@@ -0,0 +1 @@
+15
diff -ruNp ejudge-2.3.18/contest-1/problems/B/tests/002.ans ejudge/contest-1/problems/B/tests/002.ans
--- ejudge-2.3.18/contest-1/problems/B/tests/002.ans	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/B/tests/002.ans	2011-07-11 09:02:01.141335895 +0400
@@ -0,0 +1 @@
+996
diff -ruNp ejudge-2.3.18/contest-1/problems/B/tests/003.ans ejudge/contest-1/problems/B/tests/003.ans
--- ejudge-2.3.18/contest-1/problems/B/tests/003.ans	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/contest-1/problems/B/tests/003.ans	2011-07-11 09:02:01.142335877 +0400
@@ -0,0 +1 @@
+99556547
diff -ruNp ejudge-2.3.18/contests_2.c ejudge/contests_2.c
--- ejudge-2.3.18/contests_2.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/contests_2.c	2011-07-11 09:02:04.697270569 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: contests_2.c 6162 2011-03-27 07:07:27Z cher $ */
+/* $Id: contests_2.c 6351 2011-05-24 19:28:45Z cher $ */
 
 /* Copyright (C) 2008-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -264,6 +264,7 @@ contests_unparse(FILE *f,
     CONTEST_REGISTER_EMAIL, CONTEST_REGISTER_URL, CONTEST_TEAM_URL,
     CONTEST_STANDINGS_URL, CONTEST_PROBLEMS_URL, CONTEST_REGISTER_EMAIL_FILE,
     CONTEST_LOGIN_TEMPLATE, CONTEST_LOGIN_TEMPLATE_OPTIONS,
+    CONTEST_LOGO_URL, CONTEST_CSS_URL,
     0,
   });
 
diff -ruNp ejudge-2.3.18/contests.c ejudge/contests.c
--- ejudge-2.3.18/contests.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/contests.c	2011-07-11 09:02:04.108281398 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: contests.c 6162 2011-03-27 07:07:27Z cher $ */
+/* $Id: contests.c 6349 2011-05-24 05:20:31Z cher $ */
 
 /* Copyright (C) 2002-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -125,6 +125,8 @@ const int contests_tag_to_meta_map[CONTE
   [CONTEST_WELCOME_FILE] = CNTS_welcome_file,
   [CONTEST_REG_WELCOME_FILE] = CNTS_reg_welcome_file,
   [CONTEST_USER_CONTEST] = CNTS_user_contest,
+  [CONTEST_LOGO_URL] = CNTS_logo_url,
+  [CONTEST_CSS_URL] = CNTS_css_url,
 };
 const int contests_attr_to_meta_map[CONTEST_LAST_ATTR] =
 {
@@ -235,6 +237,8 @@ char const * const contests_elem_map[] =
   "slave_rules",
   "run_managed_on",
   "user_contest",
+  "logo_url",
+  "css_url",
 
   0
 };
@@ -753,6 +757,8 @@ static const unsigned char contest_final
   [CONTEST_WELCOME_FILE] = 1,
   [CONTEST_REG_WELCOME_FILE] = 1,
   [CONTEST_USER_CONTEST] = 1,
+  [CONTEST_LOGO_URL] = 1,
+  [CONTEST_CSS_URL] = 1,
 };
 
 static const unsigned char contest_access_set[CONTEST_LAST_TAG] =
@@ -1714,12 +1720,7 @@ contests_get_path_in_conf_dir(
     snprintf(home_dir, sizeof(home_dir), "%s", CONTESTS_HOME_DIR);
 #endif
     if (!home_dir[0]) {
-#ifdef __WIN32__
-      /* INSERT YOUR SERVER'S SAMBA ADDRESS HERE ------\/-----------------*/
-      snprintf(home_dir, sizeof(home_dir), "%s", "//192.168.244.130/judges");
-#else
       snprintf(home_dir, sizeof(home_dir), "%s", "/home/judges");
-#endif /* __WIN32__ */
     }
     if (cnts->root_dir) {
       snprintf(root_dir, sizeof(root_dir), "%s/%s", home_dir, cnts->root_dir);
diff -ruNp ejudge-2.3.18/contests.h ejudge/contests.h
--- ejudge-2.3.18/contests.h	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/contests.h	2011-07-11 09:02:04.139280826 +0400
@@ -1,10 +1,10 @@
 /* -*- c -*- */
-/* $Id: contests.h 5675 2010-01-19 09:52:11Z cher $ */
+/* $Id: contests.h 6349 2011-05-24 05:20:31Z cher $ */
 
 #ifndef __CONTESTS_H__
 #define __CONTESTS_H__
 
-/* Copyright (C) 2002-2009 Alexander Chernov <cher@ejudge.ru> */
+/* Copyright (C) 2002-2011 Alexander Chernov <cher@ejudge.ru> */
 
 /*
  * This program is free software; you can redistribute it and/or modify
@@ -116,6 +116,8 @@ enum
     CONTEST_SLAVE_RULES,
     CONTEST_RUN_MANAGED_ON,
     CONTEST_USER_CONTEST,
+    CONTEST_LOGO_URL,
+    CONTEST_CSS_URL,
 
     CONTEST_LAST_TAG
   };
@@ -368,6 +370,8 @@ struct contest_desc
   unsigned char *default_locale;
   unsigned char *welcome_file;
   unsigned char *reg_welcome_file;
+  unsigned char *logo_url;
+  unsigned char *css_url;
 
   struct xml_tree *slave_rules;
 
diff -ruNp ejudge-2.3.18/contest_tmpl.c ejudge/contest_tmpl.c
--- ejudge-2.3.18/contest_tmpl.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/contest_tmpl.c	2011-07-11 09:02:04.189279907 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: contest_tmpl.c 6162 2011-03-27 07:07:27Z cher $ */
+/* $Id: contest_tmpl.c 6349 2011-05-24 05:20:31Z cher $ */
 
 /* Copyright (C) 2005-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -268,6 +268,8 @@ contest_tmpl_clone(struct sid_state *sst
   subst_param(&cnts->register_email_file, 6, substs_from, substs_to);
   subst_param(&cnts->main_url, 6, substs_from, substs_to);
   subst_param(&cnts->standings_url, 6, substs_from, substs_to);
+  subst_param(&cnts->logo_url, 6, substs_from, substs_to);
+  subst_param(&cnts->css_url, 6, substs_from, substs_to);
 
   for (cap = cnts->capabilities.first; cap; cap = (typeof(cap)) cap->b.right)
     if (!strcmp(cap->login, login))
